//+------------------------------------------------------------------+
//|                                             Feyyaz_EA_Manual.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"



extern   double   TP                    =0.0040;
extern   double   SL                    =0.0020;

///////////////////////////////////////////////////////
extern   bool     AlislaBasla            =true;
extern   bool     SatislaBasla           =false;
extern   int      MagicNumber            =4575;    // MagicNumberi
extern   string   Bilgi                  ="--LOT Miktarlari--";
extern   double   LotMiktari0            =0.01;      //Lot Miktari
extern   double   LotMiktari1            =0.02;      //Lot Miktari
extern   double   LotMiktari2            =0.03;      //Lot Miktari
extern   double   LotMiktari3            =0.04;      //Lot Miktari
extern   double   LotMiktari4            =0.06;      //Lot Miktari
extern   double   LotMiktari5            =0.08;      //Lot Miktari
extern   double   LotMiktari6            =0.11;      //Lot Miktari
extern   double   LotMiktari7            =0.15;      //Lot Miktari
extern   double   LotMiktari8            =0.20;      //Lot Miktari
extern   double   LotMiktari9            =0.27;      //Lot Miktari
extern   double   LotMiktari10            =0.36;      //Lot Miktari
extern   double   LotMiktari11            =0.47;      //Lot Miktari
extern   double   LotMiktari12            =0.62;      //Lot Miktari
extern   double   LotMiktari13            =0.80;      //Lot Miktari
extern   double   LotMiktari14            =1.02;      //Lot Miktari
extern   double   LotMiktari15            =1.30;      //Lot Miktari
extern   double   LotMiktari16            =1.65;      //Lot Miktari
extern   double   LotMiktari17            =2.08;      //Lot Miktari
extern   double   LotMiktari18            =2.63;      //Lot Miktari
extern   double   LotMiktari19            =3.31;      //Lot Miktari
extern   double   LotMiktari20            =4.16;      //Lot Miktari
extern   double   LotMiktari21            =5.22;      //Lot Miktari
extern   double   LotMiktari22            =6.55;      //Lot Miktari
extern   double   LotMiktari23            =8.50;      //Lot Miktari
extern   double   LotMiktari24            =11.80;      //Lot Miktari
extern   double   LotMiktari25            =16.00;      //Lot Miktari
extern   double   LotMiktari26            =21.00;      //Lot Miktari
int LotSirasi=0;

string Process="Yok";
string SonSinyal="Yok";
int MagicNumberBas;
double LotMiktari;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
MagicNumberBas=MagicNumber;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
  

/////////////////Pozisyon Ac Fonksiyonu
void PozisyonAc(string Parite,int Yon,double LotMiktari, int MagicNumber, int AcacagiPozisyonSayisi, string Bilgi){
  double Fiyat;
  string bilgiyazdir="FxRbt "+Bilgi;
  for (int i=1; i<=AcacagiPozisyonSayisi; i++){
    if(Yon==OP_BUY){Fiyat=MarketInfo(Parite,MODE_ASK);}else{Fiyat=MarketInfo(Parite,MODE_BID);}
    int Ticket=OrderSend(Parite,Yon,LotMiktari,Fiyat,30,0,0,bilgiyazdir,MagicNumber,100,Green);
    if(Ticket>0){Print(Bilgi + "Pozisyon Acildi");}else{Print(Bilgi + "OrderSend Error: ",GetLastError()); i=i-1;}
  }
  return(1);
}
/////////////////Pozisyon Ac Fonksiyonu     

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {

/////////ACIK POZISYON VARMI YOKMU KONTROLU //////
int total = OrdersTotal();
int ToplamA=0;
int ToplamS=0;
double ToplamKarZarar=0;
for (int tap=0; tap<=total; tap++){
  if (OrderSelect(tap, MODE_TRADES) == true) {
   if(OrderMagicNumber()==MagicNumber || ((OrderMagicNumber()>MagicNumberBas || OrderMagicNumber()==MagicNumberBas) && (OrderMagicNumber()==MagicNumber || OrderMagicNumber()<MagicNumber))){
     if(OrderSymbol()==Symbol()){
       if(OrderType()==OP_BUY){ToplamA=ToplamA+1;}
       if(OrderType()==OP_SELL){ToplamS=ToplamS+1;}
       ToplamKarZarar=ToplamKarZarar+OrderProfit();
     }
   }
  }
}
if(ToplamA==0 && ToplamS==0){Process="Yok";LotSirasi=0;}
/////////ACIK POZISYON VARMI YOKMU KONTROLU //////

if(LotSirasi==0){LotMiktari=LotMiktari0;}
if(LotSirasi==1){LotMiktari=LotMiktari1;}
if(LotSirasi==2){LotMiktari=LotMiktari2;}
if(LotSirasi==3){LotMiktari=LotMiktari3;}
if(LotSirasi==4){LotMiktari=LotMiktari4;}
if(LotSirasi==5){LotMiktari=LotMiktari5;}
if(LotSirasi==6){LotMiktari=LotMiktari6;}
if(LotSirasi==7){LotMiktari=LotMiktari7;}
if(LotSirasi==8){LotMiktari=LotMiktari8;}
if(LotSirasi==9){LotMiktari=LotMiktari9;}
if(LotSirasi==10){LotMiktari=LotMiktari10;}
if(LotSirasi==11){LotMiktari=LotMiktari11;}
if(LotSirasi==12){LotMiktari=LotMiktari12;}
if(LotSirasi==13){LotMiktari=LotMiktari13;}
if(LotSirasi==14){LotMiktari=LotMiktari14;}
if(LotSirasi==15){LotMiktari=LotMiktari15;}
if(LotSirasi==16){LotMiktari=LotMiktari16;}
if(LotSirasi==17){LotMiktari=LotMiktari17;}
if(LotSirasi==18){LotMiktari=LotMiktari18;}
if(LotSirasi==19){LotMiktari=LotMiktari19;}
if(LotSirasi==20){LotMiktari=LotMiktari20;}
if(LotSirasi==21){LotMiktari=LotMiktari21;}
if(LotSirasi==22){LotMiktari=LotMiktari22;}
if(LotSirasi==23){LotMiktari=LotMiktari23;}
if(LotSirasi==24){LotMiktari=LotMiktari24;}
if(LotSirasi==25){LotMiktari=LotMiktari25;}
if(Process=="AlisAc")
      {
         PozisyonAc(Symbol(),OP_BUY,LotMiktari,MagicNumber, 1, "L1Buy_1");
         Process="Yok";
      }
   if(Process=="SatisAc")
      {
         PozisyonAc(Symbol(),OP_SELL,LotMiktari,MagicNumber, 1, "L1Sell_1");
         Process="Yok";
      }

if(ToplamA==0 && ToplamS==0){Process="Yok";LotSirasi=0;}



/////////Sinyal Uretim Bolumu/////////////////////
if(AlislaBasla==true && SatislaBasla==true){
Comment("Hem Alis Hem Satis true olamaz");
return(0);
}
string MainSinyal="Yok";
if(AlislaBasla){MainSinyal="AlisAc";}
if(SatislaBasla){MainSinyal="SatisAc";}
/////////Sinyal Uretim Bolumu/////////////////////


/////////Pozisyon Acma Bolumu/////////////////////
if(MainSinyal=="AlisAc" && ToplamA==0 && ToplamS==0 && (SonSinyal=="Yok" || SonSinyal=="SatisAc")){
PozisyonAc(Symbol(),OP_BUY,LotMiktari,MagicNumber, 1, "L1Buy_1");
SonSinyal="AlisAc";
}
if(MainSinyal=="SatisAc" && ToplamS==0 && ToplamA==0 && (SonSinyal=="Yok" || SonSinyal=="AlisAc")){
PozisyonAc(Symbol(),OP_SELL,LotMiktari,MagicNumber, 1, "L1Sell_1");
SonSinyal="SatisAc";
}  
/////////Pozisyon Acma Bolumu/////////////////////  






/////////Pozisyon Kontrol Bolumu/////////////////////  
int OrderTicketNumber,order_type;
double OOP,OLots;
   for (int i=0; i<=OrdersTotal(); i++) {         
      if (OrderSelect(i, SELECT_BY_POS) == true) {
        if(OrderMagicNumber()==MagicNumber){
          OrderTicketNumber=OrderTicket();
          OOP=OrderOpenPrice();
          order_type=OrderType();
          OLots=OrderLots();
          if(OrderSymbol()==Symbol() && Process=="Yok"){
            double BuyTp=OrderOpenPrice()+TP;
            double SellTp=OrderOpenPrice()-TP;
            if(order_type==OP_BUY && Bid>BuyTp){
            Process="AlayiniKapat";
            LotSirasi=0;
            }
            if(order_type==OP_SELL && Ask<SellTp){
            Process="AlayiniKapat";
            LotSirasi=0;
            }

            double BuySl=OrderOpenPrice()-SL;
            double SellSl=OrderOpenPrice()+SL;
            if(order_type==OP_BUY && Bid<BuySl){
            Process="SatisAc";
            MagicNumber=MagicNumber+1;
            LotSirasi=LotSirasi+1;
            }
            if(order_type==OP_SELL && Ask>SellSl){
            Process="AlisAc";
            MagicNumber=MagicNumber+1;
            LotSirasi=LotSirasi+1;
            }
            
            
            
          }


        }
      }
    }
/////////Pozisyon Kontrol Bolumu/////////////////////  












/////////Pozisyon Kontrol Bolumu/////////////////////  
int Loop2OrderTicketNumber,Loop2order_type;
double Loop2OOP,Loop2OLots;
   for (int Loop2i=0; Loop2i<=OrdersTotal(); Loop2i++) {         
      if (OrderSelect(Loop2i, SELECT_BY_POS) == true) {
        if(OrderMagicNumber()==MagicNumber || ((OrderMagicNumber()>MagicNumberBas || OrderMagicNumber()==MagicNumberBas) && (OrderMagicNumber()==MagicNumber || OrderMagicNumber()<MagicNumber))){
          Loop2OrderTicketNumber=OrderTicket();
          Loop2OOP=OrderOpenPrice();
          Loop2order_type=OrderType();
          Loop2OLots=OrderLots();
          if(OrderSymbol()==Symbol() && Process=="AlayiniKapat"){

          if(Loop2order_type==OP_BUY){
              OrderClose(Loop2OrderTicketNumber,Loop2OLots,Bid,0,Violet);
            }
          if(Loop2order_type==OP_SELL){
              OrderClose(Loop2OrderTicketNumber,Loop2OLots,Ask,0,Violet);
            }



          }


        }
      }
    }
/////////Pozisyon Kontrol Bolumu/////////////////////  



/////////Pozisyon Acma Bolumu/////////////////////











   return(0);
  }
//+------------------------------------------------------------------+